Package org.flowable.cmmn.model

# Class PlanFragment

java.lang.Object
org.flowable.cmmn.model.BaseElement
org.flowable.cmmn.model.CmmnElement
org.flowable.cmmn.model.CaseElement
org.flowable.cmmn.model.PlanItemDefinition
org.flowable.cmmn.model.PlanFragment

All Implemented Interfaces:
  `HasExtensionAttributes`, `HasLifecycleListeners`

Direct Known Subclasses:
  `Stage`

public class PlanFragment extends PlanItemDefinition
Even though plan fragments don't have a runtime behavior, they still need to be stored in the `CmmnModel`, as they are needed when exporting the XML. From the CMMN spec: "Unlike other PlanItemDefinitions, a PlanFragment does not have a representation in run-time, i.e., there is no notion of lifecycle tracking of a PlanFragment (not being a Stage) in the context of a Case instance. Just the PlanItems that are contained in it are instantiated and have their lifecyles that are tracked.

Author:
  Joram Barrez

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected Case`
  `caze`
  `protected PlanItem`
  `planItem`
  `protected Map<String,PlanItem>`
  `planItemDefinitionToItemMap`
  `protected Map<String,PlanItem>`
  `planItemMap`
  `protected List<Sentry>`
  `sentries`

  ### Fields inherited from class org.flowable.cmmn.model.PlanItemDefinition

  `defaultControl, lifecycleListeners, planItemRef`

  ### Fields inherited from class org.flowable.cmmn.model.CaseElement

  `name, parent`

  ### Fields inherited from class org.flowable.cmmn.model.CmmnElement

  `documentation, documentationTextFormat`

  ### Fields inherited from class org.flowable.cmmn.model.BaseElement

  `attributes, extensionElements, id, xmlColumnNumber, xmlRowNumber`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlanFragment()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addPlanItem(PlanItem planItem)`
  `void`
  `addSentry(Sentry sentry)`
  `PlanItem`
  `findPlanItemForPlanItemDefinitionInPlanFragmentOrDownwards(String planItemDefinitionId)`
  `PlanItem`
  `findPlanItemForPlanItemDefinitionInPlanFragmentOrUpwards(String planItemDefinitionId)`
  `PlanItem`
  `findPlanItemInPlanFragmentOrDownwards(String planItemId)`
  `PlanItem`
  `findPlanItemInPlanFragmentOrUpwards(String planItemId)`
  `Sentry`
  `findSentry(String sentryId)`
  `Case`
  `getCase()`
  `List<PlanItem>`
  `getDirectChildPlanItemsWithLifecycleEnabled()`
  `PlanItem`
  `getPlanItem()`
  `PlanItem`
  `getPlanItem(String planItemId)`
  `List<PlanItem>`
  `getPlanItems()`
  `List<Sentry>`
  `getSentries()`
  `void`
  `removePlanItem(PlanItem planItem)`
  `void`
  `setCase(Case caze)`
  `void`
  `setPlanItem(PlanItem planItem)`
  `void`
  `setPlanItemMap(Map<String,PlanItem> planItemMap)`
  `void`
  `setSentries(List<Sentry> sentries)`

  ### Methods inherited from class org.flowable.cmmn.model.PlanItemDefinition

  `getDefaultControl, getLifecycleListeners, getPlanItemRef, setDefaultControl, setLifecycleListeners, setPlanItemRef, setValues, toString`

  ### Methods inherited from class org.flowable.cmmn.model.CaseElement

  `getName, getParent, getParentStage, setName, setParent`

  ### Methods inherited from class org.flowable.cmmn.model.CmmnElement

  `getDocumentation, getDocumentationTextFormat, setDocumentation, setDocumentationTextFormat, setValues`

  ### Methods inherited from class org.flowable.cmmn.model.BaseElement

  `addAttribute, addExtensionElement, getAttributes, getAttributeValue, getExtensionElements, getId, getXmlColumnNumber, getXmlRowNumber, setAttributes, setExtensionElements, setId, setValues, setXmlColumnNumber, setXmlRowNumber`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### caze

    protected Case caze

  - ### planItem

    protected PlanItem planItem

  - ### planItemMap

    protected Map<String,PlanItem> planItemMap

  - ### planItemDefinitionToItemMap

    protected Map<String,PlanItem> planItemDefinitionToItemMap

  - ### sentries

    protected List<Sentry> sentries

- ## Constructor Details

  - ### PlanFragment

    public PlanFragment()

- ## Method Details

  - ### findPlanItemInPlanFragmentOrDownwards

    public PlanItem findPlanItemInPlanFragmentOrDownwards(String planItemId)

  - ### findPlanItemInPlanFragmentOrUpwards

    public PlanItem findPlanItemInPlanFragmentOrUpwards(String planItemId)

  - ### findPlanItemForPlanItemDefinitionInPlanFragmentOrUpwards

    public PlanItem findPlanItemForPlanItemDefinitionInPlanFragmentOrUpwards(String planItemDefinitionId)

  - ### findPlanItemForPlanItemDefinitionInPlanFragmentOrDownwards

    public PlanItem findPlanItemForPlanItemDefinitionInPlanFragmentOrDownwards(String planItemDefinitionId)

  - ### findSentry

    public Sentry findSentry(String sentryId)

  - ### addPlanItem

    public void addPlanItem(PlanItem planItem)

  - ### removePlanItem

    public void removePlanItem(PlanItem planItem)

  - ### getDirectChildPlanItemsWithLifecycleEnabled

    public List<PlanItem> getDirectChildPlanItemsWithLifecycleEnabled()

  - ### addSentry

    public void addSentry(Sentry sentry)

  - ### getCase

    public Case getCase()

  - ### setCase

    public void setCase(Case caze)

  - ### getPlanItem

    public PlanItem getPlanItem()

  - ### setPlanItem

    public void setPlanItem(PlanItem planItem)

  - ### getPlanItems

    public List<PlanItem> getPlanItems()

  - ### setPlanItemMap

    public void setPlanItemMap(Map<String,PlanItem> planItemMap)

  - ### getPlanItem

    public PlanItem getPlanItem(String planItemId)

  - ### getSentries

    public List<Sentry> getSentries()

  - ### setSentries

    public void setSentries(List<Sentry> sentries)